package com.diagbot.enums;

import lombok.Setter;

/**
 * @Description: 推理分类
 * @author: gaodm
 * @time: 2021/2/23 10:00
 */
public enum PushRelationTypeEnum {

    SYMPTOMMAIN(501L, "疾病相关主症状"),
    SYMPTOMSEC(502L, "疾病相关次症状"),
    VITAL(503L, "疾病相关体格检查结果"),
    LIS(504L, "疾病相关实验室检查套餐"),
    PACS(505L, "疾病相关辅助检查项目"),
    DRUG(506L, "疾病相关药物治疗"),
    OPERATION(507L, "疾病相关手术治疗"),
    DIFFDIAGNOSE(508L, "疾病相关鉴别诊断");

    @Setter
    private long key;

    @Setter
    private String name;

    PushRelationTypeEnum(long key, String name) {
        this.key = key;
        this.name = name;
    }

    public static PushRelationTypeEnum getEnum(long key) {
        for (PushRelationTypeEnum item : PushRelationTypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static String getName(long key) {
        PushRelationTypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    public long getKey() {
        return key;
    }

    public String getName() {
        return name;
    }


}
