package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.diagbot.entity.ConceptInfo;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.ConceptInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/12/28 11:47
 */
@Component
public class ConceptInfoFacade {
    @Autowired
    ConceptInfoService conceptInfoService;

    /**
     * 标准术语名称修改
     *
     * @param oldName
     * @param newName
     * @return
     */
    public Boolean updateName(String oldName, String newName, String labelType) {
        UpdateWrapper<ConceptInfo> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("name", oldName)
                .eq("type", labelType)
                .set("name", newName);
        conceptInfoService.update(updateWrapper);
        return true;
    }
}