package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.DictionaryInfoDTO;
import com.diagbot.entity.KlDictionaryInfo;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.KlDictionaryInfoServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.ListUtil;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2021/2/25 16:48
 */
@Component
public class KlDictionaryInfoFacade extends KlDictionaryInfoServiceImpl {
    /**
     * 返回字典信息
     *
     * @return
     */
    public Map<Long, List<DictionaryInfoDTO>> getList() {
        List<KlDictionaryInfo> list = this.list(new QueryWrapper<KlDictionaryInfo>()
                .in("return_type", ListUtil.arrayToList(new Long[] { 0L, 2L }))
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .orderByAsc("group_type", "order_no"));
        List<DictionaryInfoDTO> listRes = BeanUtil.listCopyTo(list, DictionaryInfoDTO.class);
        return EntityUtil.makeEntityListMap(listRes, "groupType");
    }

    /**
     * 返回字典信息
     *
     * @return
     */
    public Map<Long, List<DictionaryInfoDTO>> getListBack() {
        List<KlDictionaryInfo> list = this.list(new QueryWrapper<KlDictionaryInfo>()
                .in("return_type", ListUtil.arrayToList(new Long[] { 0L, 1L }))
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .orderByAsc("group_type", "order_no"));
        List<DictionaryInfoDTO> listRes = BeanUtil.listCopyTo(list, DictionaryInfoDTO.class);
        return EntityUtil.makeEntityListMap(listRes, "groupType");
    }


    /**
     * 返回指定字典信息
     *
     * @param groupType
     * @return
     */
    public List<DictionaryInfoDTO> getListByGroupType(Integer groupType) {
        List<KlDictionaryInfo> list = this.list(new QueryWrapper<KlDictionaryInfo>()
                .eq("group_type", groupType)
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .orderByAsc("order_no"));
        List<DictionaryInfoDTO> listRes = BeanUtil.listCopyTo(list, DictionaryInfoDTO.class);
        return listRes;
    }
}
